/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/text.h"                */
/*  Constants and definitions for text library.                              */
/*                                                                           */
/*  Author : FA                         Last modification : 20/07/2017       */
/*                                                                           */
/*  (c) Copyright Hyperpanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations ========================================================


         1  Defines
         2  Structures and typedefs
         3  Public variables
         4  Prototypes of public procedures


*/


#ifndef TEXT_H                         /* If this file is not already        */
#define TEXT_H                         /* included, include it.              */


/*
    1    Defines
    _____________
*/


/*
    2    Structures and typedefs
    _____________________________
*/


/*
    3    Public variables
    _____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
*/


/*  4.1  Prototypes des proceduresde "hyp_lib.c" ...........................*/

#ifndef _STRICMP_                      /* Si proceduresnon fournies.        */
  IWORD strnicmp            (const CHAR*,const CHAR*,IWORD                   );
  IWORD stricmp             (const CHAR*,const CHAR*                         );
#endif

  IWORD hsprintf            (CHAR*,const VA_ALIST                            );
  IWORD hsscanf             (CHAR*,const VA_ALIST                            );

  /* hyp_lib.c shall be compiled with HAS_TERM flag to have these procedures */
  IWORD hprintf             (const VA_ALIST                                  );
  IWORD hscanf              (const VA_ALIST                                  );


/*  4.2  Prototypes des proceduresde "txt_file.c" ..........................*/

  IWORD read_text_buf       (INT ,UCHAR [],INT ,INT ,INT *                   );
  IWORD write_text_buf      (INT ,UCHAR [],INT ,INT *                        );
  IWORD write_textbuf       (INT ,CHAR [],INT ,INT ,INT                      );
  IWORD write_trans_buffer  (INT ,UCHAR *                                    );
  IWORD trans_buffer        (UCHAR []                                        );
  IWORD save_text           (CHAR [],CHAR []                                 );
  IWORD load_text           (CHAR [],CHAR [],INT                             );
  IWORD trans_buffer4       (UCHAR *,UCHAR *,INT ,INT                        );
  IWORD read_textbuf        (INT ,CHAR [],INT ,INT                           );
  IWORD read_textlines      (INT ,CHAR [],INT ,INT ,INT ,INT ,INT *          );
  IWORD transcode_texte     (UCHAR *,UCHAR *,INT ,UCHAR **,INT ,INT *        );
  IWORD real_to_string      (DOUBLE ,CHAR *,INT                              );
  IWORD str_cmp             (CHAR *,CHAR *,INT ,INT *                        );
  IWORD string_to_real      (CHAR *,DOUBLE *                                 );
  IWORD string_string       (CHAR[],INT,INT,CHAR[],INT,CHAR[],INT,INT*,INT*  );


/* 4.3  Prototypes des proceduresde "txt_lib.c" ........................... */

#ifndef __cplusplus
  IWORD delete              (INT,UCHAR*,INT,INT,INT                          );
#endif                      
                            
  IWORD compact             (INT,UCHAR*,INT,INT,INT,INT                      );
  IWORD compare             (INT,UCHAR*,INT,INT,UCHAR*,INT,INT,INT*          );
  IWORD convert             (INT,UCHAR*,INT,INT,INT,INT                      );
  IWORD count               (INT,UCHAR*,INT,INT*                             );
  IWORD extract             (INT,UCHAR*,INT,INT,INT,UCHAR*                   );
  IWORD extract2            (INT,UCHAR*,INT,INT,INT,INT,UCHAR*               );
  IWORD insert              (INT,UCHAR*,INT,INT,UCHAR*,INT,INT,INT           );
  IWORD insert2             (INT,UCHAR*,INT,INT,UCHAR*,INT,INT,INT,INT       );
  IWORD replace             (INT,UCHAR*,INT,INT,INT,UCHAR*,INT,INT,INT       );
  IWORD replace2            (INT,UCHAR*,INT,INT,INT,UCHAR*,INT,INT,INT,INT   );
  IWORD search              (INT,UCHAR*,INT,INT,INT,UCHAR*,INT,INT*          );
  IWORD bcompact            (UCHAR*,INT,INT,INT                              );
  IWORD bcompare            (UCHAR*,INT,UCHAR*,INT,INT,INT*                  );
  IWORD bconvert            (UCHAR*,INT,INT,INT                              );
  IWORD bcount              (UCHAR*,INT*                                     );
  IWORD bdelete             (UCHAR*,INT,INT                                  );
  IWORD bextract            (UCHAR*,INT,INT,UCHAR*                           );
  IWORD binsert             (UCHAR*,INT,UCHAR*,INT,INT                       );
  IWORD binsert2            (UCHAR*,INT,UCHAR*,INT,INT,INT                   );
  IWORD breplace            (UCHAR*,INT,INT,UCHAR*,INT,INT                   );
  IWORD bsearch2            (UCHAR*,INT,INT,UCHAR*,INT,INT*                  );
  IWORD bextract2           (UCHAR*,INT,INT,INT,UCHAR*                       );
  IWORD convert_position    (INT,INT,UCHAR*,INT*,INT*,INT*                   );
  IWORD isprintf            (UCHAR*,UCHAR*,INT                               );
  IWORD isscanf             (UCHAR*,INT*                                     );
  IWORD string_to_integer   (CHAR*,INT*                                      );
  IWORD get_extension       (CHAR [],CHAR []                                 );
  IWORD set_extension       (CHAR [],CHAR [],CHAR []                         );
  IWORD get_random          (INT ,INT *                                      );
  IWORD string_cmp          (UCHAR *,UCHAR *,INT ,INT, INT, INT *            );
  IWORD hstring_cmp         (UCHAR *,UCHAR *,INT, INT, INT, INT *            );
  IWORD transcod_text       (UCHAR*,UCHAR*,INT,UCHAR**,INT,INT*              );
  IWORD cmpstr              (CHAR *,CHAR *                                   );
  IWORD cmpstrn             (CHAR *, CHAR *,INT                              );
  IWORD getpline            (CHAR [],CHAR **,INT                             );
  IWORD insertcara          (CHAR [],INT ,INT ,INT                           );
  IWORD getnbltext          (CHAR *                                          );
  IWORD is_letter_or_number (UIWORD                                          );


#endif                                 /* End of TEXT_H.                     */
