#!  /bin/sh
#
#   Hyperpanel VMOS environment         File "stm32py/exe/hypenv.sh"
#   Specific environment - VMOS - stm32py - Pyboard
#
#   Author : FA                         Last modification : 10/11/2018
#
#   (c) Copyright HyperPanel Lab, All Rights Reserved.
#   IDDN.FR.001.320001.*.S.P.1990.000.10000
#
#


#   Syntax : Called by environment files.


# Some specific declarations --------------------------------------------------

  unalias -a                                            # Remove all alias.
                                                        #
# Commands paths --------------------------------------------------------------    
  PATH="."                                              # Commands paths. 
  PATH="$PATH:/usr/local/sbin:/usr/local/bin"           # Commands paths.  
  PATH="$PATH:/usr/sbin:/usr/bin"                       # Commands paths.  
  PATH="$PATH:/sbin:/bin"                               # Commands paths.  
  PATH="$PATH:$hlocal/$hvm/exe"                         # Commands paths.  
  PATH="$PATH:$hhome/$hvm/exe"                          # Commands paths.   
  PATH="$PATH:$hhome/os/linux"                          # Commands paths.  


# Include files paths ---------------------------------------------------------

  export hinclude="-I."                                 # Include files path.
  export hinclude="$hinclude -I$hhome/$hvm/src"         # Include files path.
  export hinclude="$hinclude -I$hhome/include"          # Include files path.
  export hinclude="$hinclude -I$hhome/package"          # Include files path.
  export hinclude="$hinclude -I/usr/lib/gcc/arm-none-eabi/4.9.3/include"


# Defines directives ----------------------------------------------------------

  export hdef=""                                        # Defines.


# Compiler / linker directives ------------------------------------------------
# GCC generates incorrect code for "headbloc" (drv.c) as soon as optimization
# level is 1,2 or 3. As we do not know if this may happen with other codes
# then we use -O0
 
  export hcc="arm-none-eabi-gcc"                        # Compiler command.
  export hamm="arm-none-eabi-as"                        # Assembly compiler.
  export har="arm-none-eabi-ar"                         # Archive builder.
  export hlnk="arm-none-eabi-ld"                        # Linker command.
  export hocp="arm-none-eabi-objcopy"                   # Binary converter.
  export hnm="arm-none-eabi-nm"                         # Object analyzer.
  export hod="arm-none-eabi-objdump"                    # Object analyzer.
  export hnmpre=""                                      # Symbol prefix for nm.
                                                        #
  hop="-fno-strict-aliasing"                            # Compiler options.
  hop="$hop -fsigned-char"                              # Compiler options.
  hop="$hop -fno-builtin"                               # Compiler options.
  hop="$hop -nostdinc"                                  # Compiler options.
  hop="$hop -Wall"                                      # Compiler options.
  hop="$hop -Wno-missing-braces"                        # Compiler options.
  hop="$hop -Wno-unused-function"                       # Compiler options.
  hop="$hop -Wno-maybe-uninitialized"                   # Compiler options.
  hop="$hop -mcpu=cortex-m4"                            # Compiler options.
  hop="$hop -mlittle-endian"                            # Compiler options.
  hop="$hop -mthumb"                                    # Compiler options.
  hop="$hop -mtune=cortex-m4"                           # Compiler options.
  hop="$hop -mfloat-abi=hard"                           # Compiler options.
  hop="$hop -mfpu=fpv4-sp-d16"                          # Compiler options.
  hop="$hop -fsingle-precision-constant "               # Compiler options.
                                                        #
  hgdb="arm-none-eabi-gdb"                              # ARM debugger.
  hgdb="$hgdb -nh"                                      # Ignore cmd from home.
  hgdb="$hgdb -nx"                                      # Ignore cmd from file.
  hgdb="$hgdb -x $hhome/$hvm/exe/gdb.cfg"               # Config. file for dbg.
  export hgdb                                           # Debugger.
                                                        #
  export hoptstd="-c -g -O0 $hop"                       # Standard options.
  export hoptdbg="-c -g3 -O0 $hop"                      # Debug options.
                                                        #
  export haopt="-g"                                     # Assembler options.
  export haopt="$haopt -mcpu=cortex-m3"                 # Assembler options.
  export haopt="$haopt -mlittle-endian"                 # Assembler options.
  export haopt="$haopt -mthumb"                         # Assembler options.
                                                        #
  export hlopt="-nostdlib --cref --warn-common"         # Linker options.
                                                        #
  export hlib="-L/usr/lib/gcc/arm-none-eabi/4.9.3"      # Additional libraries.
