
/*
**  Myio.h - Sample code for simple I/O functions ============== 02/01/19 =  **
**                                                                           **
**                                                                           **
**  =======================================================================  **
*/

/* Defines of this module -------------------------------------------------- */

#define DRVASY                      0  // ASY  driver identifier
#define DRVGPIO                     1  // GPIO driver identifier
#define DRVLED                      2  // LED  driver identifier
#define DRVKBD                      3  // KBD  driver identifier
#define DRVDAC                      4  // DAC  driver identifier
#define MAX_MODD                    5  // Count of used drivers

#define DEV0                        0  // device "DEV0"
#define DEV1                        1  // device "DEV1"
#define DEV2                        2  // device "DEV1"
#define MAX_DEV                     3  // Maximum count of devices per driver


/* Interface procedures prototypes ----------------------------------------- */

int myio_open          (int,int,const char*,int*                             );
int myio_close         (int                                                  );
int myio_alloc_sub     (int,const char*,int*                                 );
int myio_free_sub      (int                                                  );
int myio_getval        (int,char*,int                                        );
int myio_setval        (int,const char*                                      );
int myio_givetok       (int,int,int,int*                                     );
int myio_write         (int,unsigned char*,int                               );
int myio_send          (int,unsigned char*,int,int*                          );


